﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.Page
{
    /// <summary>
    /// This method handles the page load event
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Page_Load(object sender, EventArgs e)
    {
        // Make sure that the pageload not is a post back
        if (Page.IsPostBack == false)
        {

            // Get all the categories
            List<ImageMapCategory> categories = ImageMapCategory.GetAll();

            // Create buttons for all the categories
            for (int i = 0; i < categories.Count; i++)
            {
                // Create the link for the mobile links container
                string buttonText = "<div class=\"annytab-imap-mobile-show-imagemap\" data-category=\"" + categories[i].id + "\" data-name=\"" 
                    + categories[i].name + "\">" + categories[i].name + "</div>";

                // Add the link to the mobile category container
                this.categoryLinksMobileContainer.InnerHtml += buttonText;

                //// Create the link for the default category container
                //buttonText = "<div class=\"annytab-imap-show-imagemap\" data-category=\"" + categories[i].id + "\" data-name=\""
                //    + categories[i].name + "\">" + categories[i].name + "</div>";

                //// Add the link to the default category container
                //this.categoryLinksDefaultContainer.InnerHtml += buttonText;
            }

            // Get all the image maps
            List<ImageMap> imageMaps = ImageMap.GetAll();

            // Create the select image maps control
            for (int i = 0; i < imageMaps.Count; i++)
            {

                // Get the width and height for the image
                System.Drawing.Image image = System.Drawing.Image.FromFile(Server.MapPath(imageMaps[i].image_url));

                // imageUrl, width, height : Product id, product name, product price, 
                string hiddenProductData = imageMaps[i].image_url + "," + image.Size.Width + "px," + image.Size.Height + "px|";

                // Dispose of the image
                image.Dispose();

                // Get the map points
                string[] mapPoints = imageMaps[i].image_map_points.Split(';');

                // Loop image points
                for (int j = 0; j < mapPoints.Length; j++)
                {
                    if (mapPoints[j] == "")
                        continue;

                    // Get the map point data
                    string[] mapPointData = mapPoints[j].Split(',');

                    // Get the product
                    Product product = Product.GetOneById(Convert.ToInt32(mapPointData[0]));

                    // Add information about the point to the hidden data field
                    hiddenProductData += product.id + "," + product.name + "," + product.price + "," + product.image_url + ","
                        + product.page_name + "," + mapPointData[1] + "," + mapPointData[2];

                    if (j != (mapPoints.Length - 1))
                        hiddenProductData += ";";
                }

                // Create the mobile select image map control
                string controlText = "<div data-id=\"" + imageMaps[i].id + "\" data-category=\"" + +imageMaps[i].category_id + "\" data-points=\"" + hiddenProductData + "\" runat=\"server\" class=\"annytab-imap-mobile-imagemap-button\" style=\"background-image:url('"
                    + imageMaps[i].image_url + "');\"></div>";

                // Add the div
                this.annytabImapMobileSelectImage.InnerHtml += controlText;

                //// Create the default select image map control
                //controlText = "<div data-id=\"" + imageMaps[i].id + "\" data-category=\"" + +imageMaps[i].category_id + "\" data-points=\"" + hiddenProductData + "\" runat=\"server\" class=\"annytab-imap-imagemap-button\" style=\"background-image:url('"
                //    + imageMaps[i].image_url + "');\"></div>";

                //// Add the div
                //this.annytabImapSelectImage.InnerHtml += controlText;
            }

            // Add links to spinning images
            AddLinksToSpinningImages();

        } // End of if (Page.IsPostBack == false)

    } // End of the Page_Load method

    /// <summary>
    /// Add links to spinning images
    /// </summary>
    private void AddLinksToSpinningImages()
    {
        // Get all the spinning images
        List<SpinningImage> images = SpinningImage.GetAll();

        // Create links for all images
        for (int i = 0; i < images.Count; i++)
        {
            // Get the product
            Product product = Product.GetOneById(images[i].product_id);

            // Get all the images
            string filePath = "images/spinning_images/" + images[i].product_id + "/";
            string serverFilePath = Server.MapPath(filePath);
            string[] extensions = new string[] { "*.jpg", "*.png", "*.gif" };
            List<string> fileNames = new List<string>(36);
            string fileNameString = "";

            // Get all the images in the folder
            for (int j = 0; j < extensions.Length; j++)
            {
                // Get all the files with a certain extension
                string[] extensionFiles = Directory.GetFiles(serverFilePath, extensions[j]);

                // Loop each file in the string array
                foreach (string file in extensionFiles)
                {
                    // Add the fileName
                    fileNames.Add(filePath + Path.GetFileName(file));
                }
            }

            // Add filenames to the filename string
            for (int j = 0; j < fileNames.Count; j++)
            {
                fileNameString += fileNames[j];

                if (j < (fileNames.Count - 1))
                    fileNameString += "|";
            }


            // Create the link text
            string buttonText = "<div class=\"annytab-spin-show-image\" data-id=\"" + images[i].product_id + "\" data-images=\""
                + fileNameString + "\" data-name=\"" + product.name + "\">" + "360 degree image of " + product.name + "</div><br />";

            // Add the link
            this.imageLinks.InnerHtml += buttonText;
        }

    } // End of the AddLinksToSpinningImages method

} // End of the class